library verilog;
use verilog.vl_types.all;
entity adc_model is
    generic(
        IDLE            : integer := 0;
        CONV_START      : integer := 1;
        SET_BUSY_FLAG   : integer := 2;
        WRITE_ADC_WORD  : integer := 3;
        WRITE_ADC_WORD_DELAY: integer := 4;
        CS_DE_ASSERTED  : integer := 5
    );
    port(
        CLK             : in     vl_logic;
        RESET           : in     vl_logic;
        AD_DATA         : out    vl_logic_vector(7 downto 0);
        AD_BUSY         : out    vl_logic;
        AD_REFOUT       : out    vl_logic;
        AD_CSL          : in     vl_logic;
        AD_RDL          : in     vl_logic;
        AD_CONVST       : in     vl_logic;
        ADC_MULTI_CHANNEL: in     vl_logic;
        ADC_CONVERSION_REG: in     vl_logic_vector(7 downto 0);
        ADC_SETUP_REG   : in     vl_logic_vector(7 downto 0);
        ADC_AVERAGING_REG: in     vl_logic_vector(7 downto 0);
        ADC_RESET_REG   : in     vl_logic_vector(7 downto 0)
    );
    attribute mti_svvh_generic_type : integer;
    attribute mti_svvh_generic_type of IDLE : constant is 1;
    attribute mti_svvh_generic_type of CONV_START : constant is 1;
    attribute mti_svvh_generic_type of SET_BUSY_FLAG : constant is 1;
    attribute mti_svvh_generic_type of WRITE_ADC_WORD : constant is 1;
    attribute mti_svvh_generic_type of WRITE_ADC_WORD_DELAY : constant is 1;
    attribute mti_svvh_generic_type of CS_DE_ASSERTED : constant is 1;
end adc_model;
