library verilog;
use verilog.vl_types.all;
entity spi_communications is
    generic(
        IDLE            : integer := 0;
        START           : integer := 1;
        LATCH_COMMAND   : integer := 2;
        CHECK_READ_WRITE_FLAG: integer := 3;
        MEMORY_RD_ASSERT_OE: integer := 4;
        MEMORY_RD_ADDRESS: integer := 5;
        MEMORY_RD_DATA  : integer := 6;
        MEMORY_RD_LATCH : integer := 7;
        START_SPI_TRANSMIT: integer := 8;
        WAIT_FOR_SPI_COMPLETE: integer := 9;
        CHECK_SPI_COMPLETE: integer := 10;
        START_SPI_TRANSMIT_DELAY: integer := 11;
        START_SPI_RECEIVE: integer := 12;
        MEMORY_WRITE_CYCLE: integer := 13;
        MEMORY_WR_ADDRESS: integer := 14;
        MEMORY_WR_DATA  : integer := 15;
        MEMORY_WR_LATCH : integer := 16
    );
    port(
        CLK             : in     vl_logic;
        RST_N           : in     vl_logic;
        SPI_DATA_OUT    : out    vl_logic;
        SPI_CLK         : out    vl_logic;
        SPI_DATA_IN     : in     vl_logic;
        SPI_CS_N        : out    vl_logic;
        MEMORY_ADDRESS  : inout  vl_logic_vector(7 downto 0);
        MEMORY_DATA     : inout  vl_logic_vector(7 downto 0);
        MEMORY_WRITE_LATCH: out    vl_logic;
        MEMORY_READ_LATCH: out    vl_logic;
        MEMORY_OUTPUT_ENABLE: out    vl_logic;
        SPI_COMMAND     : in     vl_logic_vector(7 downto 0);
        SPI_COMMAND_LATCH: in     vl_logic;
        SPI_TRANSMIT_COMPLETE: out    vl_logic;
        SPI_BYTE_RECEIVED: out    vl_logic;
        REQUEST_EN      : out    vl_logic;
        GRANT_RDY       : in     vl_logic
    );
    attribute mti_svvh_generic_type : integer;
    attribute mti_svvh_generic_type of IDLE : constant is 1;
    attribute mti_svvh_generic_type of START : constant is 1;
    attribute mti_svvh_generic_type of LATCH_COMMAND : constant is 1;
    attribute mti_svvh_generic_type of CHECK_READ_WRITE_FLAG : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_ASSERT_OE : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_ADDRESS : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_DATA : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_LATCH : constant is 1;
    attribute mti_svvh_generic_type of START_SPI_TRANSMIT : constant is 1;
    attribute mti_svvh_generic_type of WAIT_FOR_SPI_COMPLETE : constant is 1;
    attribute mti_svvh_generic_type of CHECK_SPI_COMPLETE : constant is 1;
    attribute mti_svvh_generic_type of START_SPI_TRANSMIT_DELAY : constant is 1;
    attribute mti_svvh_generic_type of START_SPI_RECEIVE : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_WRITE_CYCLE : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_WR_ADDRESS : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_WR_DATA : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_WR_LATCH : constant is 1;
end spi_communications;
