library verilog;
use verilog.vl_types.all;
entity uc_controller is
    generic(
        HOST_IDLE       : integer := 0;
        HOST_WR_ADDRESS : integer := 1;
        HOST_WR_DATA    : integer := 2;
        HOST_WR_COMPLETE: integer := 3;
        HOST_RD_OUTPUT_EN: integer := 4;
        HOST_RD_ADDRESS : integer := 5;
        HOST_RD_DATA    : integer := 6;
        HOST_RD_COMPLETE: integer := 7;
        MEMORY_IDLE     : integer := 0;
        MEMORY_WR_ADDRESS: integer := 1;
        MEMORY_WR_DATA  : integer := 2;
        MEMORY_WR_COMPLETE: integer := 3;
        MEMORY_RD_OUTPUT_EN: integer := 4;
        MEMORY_RD_ADDRESS: integer := 5;
        MEMORY_RD_DATA  : integer := 6;
        MEMORY_RD_COMPLETE: integer := 7;
        CONTROL_REG_IDLE: integer := 0;
        CR_NUMBER_RECIEVED: integer := 1;
        LATCH_CR_NUMBER : integer := 2;
        WAIT_FOR_CR_CONTENTS: integer := 3;
        LATCH_CR_CONTENTS: integer := 4;
        CR_COMPLETE     : integer := 5
    );
    port(
        CLK             : in     vl_logic;
        RST_N           : in     vl_logic;
        HOST_INTERFACE_ADDRESS: in     vl_logic_vector(7 downto 0);
        HOST_INTERFACE_DATA: inout  vl_logic_vector(7 downto 0);
        HOST_INTERFACE_WRITE_LATCH: in     vl_logic;
        HOST_INTERFACE_READ_LATCH: in     vl_logic;
        HOST_INTERFACE_OUTPUT_ENABLE: in     vl_logic;
        HOST_CONTROL_REG_NUMBER: in     vl_logic_vector(7 downto 0);
        HOST_CONTROL_REG_CONTENTS: inout  vl_logic_vector(7 downto 0);
        HOST_CONTROL_REG_NUMBER_LATCH: in     vl_logic;
        HOST_CONTROL_REG_CONTENTS_LATCH: in     vl_logic;
        CR_0            : out    vl_logic_vector(7 downto 0);
        CR_1            : out    vl_logic_vector(7 downto 0);
        CR_2            : out    vl_logic_vector(7 downto 0);
        CR_3            : out    vl_logic_vector(7 downto 0);
        CR_4            : out    vl_logic_vector(7 downto 0);
        CR_5            : out    vl_logic_vector(7 downto 0);
        CR_6            : out    vl_logic_vector(7 downto 0);
        CR_7            : out    vl_logic_vector(7 downto 0);
        MEMORY_INTERFACE_ADDRESS: in     vl_logic_vector(7 downto 0);
        MEMORY_INTERFACE_DATA: inout  vl_logic_vector(7 downto 0);
        MEMORY_INTERFACE_WRITE_LATCH: in     vl_logic;
        MEMORY_INTERFACE_READ_LATCH: in     vl_logic;
        MEMORY_INTERFACE_OUTPUT_ENABLE: in     vl_logic;
        MEMORY_INTERFACE_EN: in     vl_logic;
        MEMORY_INTERFACE_RDY: out    vl_logic;
        TIMEOUT_TICK    : in     vl_logic_vector(18 downto 0);
        ERROR_OUT       : out    vl_logic_vector(7 downto 0);
        STATE_OUT       : out    vl_logic_vector(3 downto 0)
    );
    attribute mti_svvh_generic_type : integer;
    attribute mti_svvh_generic_type of HOST_IDLE : constant is 1;
    attribute mti_svvh_generic_type of HOST_WR_ADDRESS : constant is 1;
    attribute mti_svvh_generic_type of HOST_WR_DATA : constant is 1;
    attribute mti_svvh_generic_type of HOST_WR_COMPLETE : constant is 1;
    attribute mti_svvh_generic_type of HOST_RD_OUTPUT_EN : constant is 1;
    attribute mti_svvh_generic_type of HOST_RD_ADDRESS : constant is 1;
    attribute mti_svvh_generic_type of HOST_RD_DATA : constant is 1;
    attribute mti_svvh_generic_type of HOST_RD_COMPLETE : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_IDLE : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_WR_ADDRESS : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_WR_DATA : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_WR_COMPLETE : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_OUTPUT_EN : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_ADDRESS : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_DATA : constant is 1;
    attribute mti_svvh_generic_type of MEMORY_RD_COMPLETE : constant is 1;
    attribute mti_svvh_generic_type of CONTROL_REG_IDLE : constant is 1;
    attribute mti_svvh_generic_type of CR_NUMBER_RECIEVED : constant is 1;
    attribute mti_svvh_generic_type of LATCH_CR_NUMBER : constant is 1;
    attribute mti_svvh_generic_type of WAIT_FOR_CR_CONTENTS : constant is 1;
    attribute mti_svvh_generic_type of LATCH_CR_CONTENTS : constant is 1;
    attribute mti_svvh_generic_type of CR_COMPLETE : constant is 1;
end uc_controller;
